
/*
slave device:
1. 0.91 inch 128x32 oled display with driver ssd1306, addr=0x3C

or use the simulated slave device by WemosD1mini:
1. scl is D6(gpio12)
2. sda is D7(gpio13)
3. the master funciic.SpeedUp() has to be disabled(do not use it).
4. master iic may bring up first then slave, which is not ok, so, delay u8g2 object in master setup(). or see 6.
5. do not connect to the other wemosd1mini while flash programming.
6. press both reset buttons if power on failure. release slave first then master and then master repeatedly till ok.
7. code:
*/

#include"functionaliic.h"

SRAM_ACES void scb_testr(unsigned x){}
SRAM_ACES void scb_testw(unsigned &x){static unsigned u=0xA1; x=(0xFF&u++);}

cIicSlave sa(0x3C, scb_testr, scb_testw); // a slave with addr=0x3C(7b) generated.

void setup(){
    // it must set at least these pins as input for wemos d1 mini interconnected.
    pinMode(1, INPUT);
    pinMode(3, INPUT);
    pinMode(4, INPUT);
    pinMode(5, INPUT);
}

void loop(){}
