

#if 0
/*
說明：
1. 若有什麼地方編不過，請搜尋與其相關的函式庫並安裝之。例如出現 ESP8266httpUpdate.h 找不到這支檔案。谷歌一下它所屬的第三方函式庫。
2. 我把與 Serial 有關的程式行，都外括了 MY_DBG(x)。建議仿之。使得 #define MYDEBUG 0，設成 0， 即可取消所有 print-out。以騰出 tx/rx 兩支 GPIO。
        畢竟手持式使用／IoT 應用，鮮少還掛著 UART。
3. 此程式碼用上了我另外寫的一支函式庫，請安裝之。Esp8266Vars2File.h。
        簡介一下這支函式庫，使用 littlefs，即包裝了 littlefs：
            於 arduino ide 中所規劃的 filesystem（一定會存在，大小自訂）。當裝置 flashed 後，第一次啟動，即會格式化此 filesystem，
            使得後續可以作檔案的建立，讀取，增刪修等。例如， WeMos D1 R1 板子，預設就是規劃成 2MB code-sketch 空間，2MB filesystem.
            此函式庫可將變數，字串，串流進來的資料，以變數 or buffer 的形式，很輕易地寫入檔案。與之後輕易地被載入。如此程式內例。
            另外還可 dir 目錄內容，且能以 Serial or 網頁將 dir 結果 dump 出來。
            可 remove file，format 等。
            其餘的用法請自行研究。

        unsigned char buff[32];
        cDataBase db("/settings");
        db.Open();
        db.ReadWords(boot_up_times, "boot_up_times");
        db.ReadWords(wifi_ap_credential_idx, "wifi_ap_credential_idx");
        db.ReadWords(ap_mode_or_sta_mode, "ap_mode_or_sta_mode");

        buff[0]=0; db.ReadData(buff, 32, "ap_credential_custom_name", 0); ap_credential_custom_name=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "ap_credential_custom_pw", 0); ap_credential_custom_pw=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "sta_credential_custom_name", 0); sta_credential_custom_name=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "sta_credential_custom_pw", 0); sta_credential_custom_pw=(char*)buff;

    ===================

    server_p->on("/setap", [](){ // ?n=<i>.
        String n=server_p->arg("n");
        int nn=n.toInt()-1;
        if (nn>=0 && nn<sizeof(WIFI_CRED)/sizeof(WIFI_CRED[0])) wifi_ap_credential_idx=nn;
        else wifi_ap_credential_idx=0;

        #if MYDB
            cDataBase("/settings").ReplaceWordsEx("wifi_ap_credential_idx", 0, wifi_ap_credential_idx);
        #endif // MYDB

        server_p->send(200, "text/plain", (String(WIFI_CRED[wifi_ap_credential_idx][0])+" chosen.").c_str());
    });



    基於此，此程式，預設啟動是 AP mode。
    開啟本地端的網頁，例如，http://192.168.4.1/getap
    即會列出目前此 AP 有寫定哪些 ssid/password
    其由以下這陣列所設定。此陣列可直接追加，增刪修字串即可。
    預設是使用 第一行 {"ESP_TESTAP", "87654321"} 。


const char *const WIFI_CRED[][2]={ // wifi credential
    {"ESP_TESTAP", "87654321"}, // the first one will be used which is in AP mode.
    {"Office", "123456"},
    {"Xperia X Performance_bc10", "e848acbcfd98"},
    {"etc", "etc"},
};


    透過例如下達，
    http://192.168.4.1/setap?n=4
        則會將 ssid/password 設定為 {"etc", "etc"} 這組,
    下次斷電重新啟動，就需以這組作為登入。即，可 runtime 改變 wifi credential。

4. 透過下達，
    http://192.168.4.1/tosta
    則會立即重新啟動，並以 sta 的模式運作。而 sta 所使用的 ssid/password 也是 const char *const WIFI_CRED[][2] 第一組。
    此後每次重啟將都以 sta mode 運作。除非再次執行 http://192.168.4.2/toap 則會切換回來 ap mode 並立即重啟。

    為避免 sta mode，當下沒有 ap 進入點，那此裝置便無法透過 http 存取。故，於 sta mode 下，每重啟十次，
    會自動切換回一次 ap mode（將設計成透過閃燈來告知）。以使得可用手機向它作 http request，以更改其相關設定。

    再者，可 runtime 設定一組 ssid/password：假設帶此裝置來到某地，要使用此地方的 router, 其 ssid=ABC, passwrod=123,
    那麼對此裝置可下達：
    http://ip_addr/credential?r=sta&n=ABC&p=123
    再以 sta 的模式重新啟動，則此裝置即可登入此地的 AP 接入點。
    要移除此設定，回復前次設定，則下空字串： http://ip_addr/credential?r=sta&n=&p=.

    同理，AP mode 下，要建立一個臨時的 credential (XYZ, 999)，下達
    http://ip_addr/credential?r=ap&n=XYZ&p=999

5. 支援 mDNS，我實測 linux firefox 是可抓得到，即透過 mdns hostname 存取裝置。
此裝置是 http://esp8266-iot-XXXXX.local/
其中，XXXXX 由 #define LSERVICE_1 "gesture-center"   所指定。故是，http://esp8266-iot-gesture-center.local/

6. 支援完整的 mDNS，即，若有相同 n 個裝置在同一網域，則，衝突的 device 將會自動更名成，例如，
http://esp8266-iot-gesture-center-1.local/
http://esp8266-iot-gesture-center-2.local/
...
...
http://esp8266-iot-gesture-center-(n-1).local/

7. 此裝置將會 query 已知的 services，已知的列表，由

const smDnsRecord mdns_sskn[]={ // for mdns. the known services this device needs from other devices.
    {"http", 80, "tcp"},
    {"https", 443, "tcp"},
    {"test", 81, "tcp"},
    {"motor", 8080, "tcp"},

    {"multicast", 8888, "udp"},

};

所指定。此表可直接追加／增刪修。

services 的用處請自行谷歌。簡單講就是在網域中，探尋提供某服務的裝置並取得其 hostname or ip，使得可以既定的方式去使用該服務，相當實用!

8. 探尋 services，由三個函式達成。

unsigned mDnsQueryStart(const char *serv_name, const char *serv_protocol);
回傳找到幾個 ("serv_name", "serv_protocol")，例如 ("motor", "tcp").

bool mDnsQueryCont(unsigned idx, IPAddress &ip, unsigned &port, String &hostname);

抓取，例如找到 5 個，由 idx 索引第幾個(0 to 4) 它的 ip, port(例如 80), hostname(例如 esp8266-iot-gesture-center-8)

void mDnsQueryEnd();
搜完一定要呼叫這個。

再例如我找到 "printer"，我便可以約定的方式傳送 data 讓它 print-out 出來。

9. multicast，稍微看一下 code 應就會使用。簡單講單純地透過全域變數 multicast_got_or_put_str 來存取資料。

10. 不管 sta mode or ap mode，都有啟用 http server，另外也啟用了 update。即，若目前網址是 http://esp8266-iot-gesture-center.local/

則下達 
http://esp8266-iot-gesture-center.local/update

便可進入燒錄網頁。將 bin file 上傳，再按更新，便可成功燒錄。


11. 支援到遠端取檔更新，例如我有一支 bin file 放在 http://tw.yahoo.com/esp8266_upd_v25.bin，則指定此網址，便可從該處下載並成功燒錄：
如何編譯後産生 bin file，谷歌一下就有。

        下達，指定更新檔來源。
    http://esp8266-iot-gesture-center.local/webupdinfo?addr=http://tw.yahoo.com/esp8266_upd_v25.bin
    再下達
        http://esp8266-iot-gesture-center.local/forceupdate
    則立即啟動更新。

//12. http web server, mdns, update 相關的功能，每 75ms 自動輸詢一次。所以此程式不用動到什麼，除了每三秒閃一下燈，都自動運作。



以上功能我都有測過 pass.

*/
#endif








// ap/sta mode. version 20210718.0.2.
// ap/sta mode. version 20210727.0.2a. added TC how-to.

#define MY_VERSION_NUMBER "[20210718.0.2]"

#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <ESP8266HTTPUpdateServer.h>
#include <ESP8266httpUpdate.h>
#include <ESP8266mDNS.h>
#include <ESP8266WiFiMulti.h>
#include <WiFiUdp.h>


#define MYDB 1
#if MYDB
    #include"Esp8266Vars2File.h" // if it is not used, must set ap_mode_or_sta_mode either AP(0) or STA(1).
    // for this lib being supported, the ap/sta mode is kept even poweroff.
    // and even which mode set, every 10 times of power up, the ap mode will be used once. reboot to recover.
#endif // MYDB


#define MYDEBUG 1
#if MYDEBUG
    #define MY_DBG(x) x
#else
    #define MY_DBG(x)
#endif


// -------------------------- for part of hostname --- note: this config will be a service info as well -----------------------
#define LSERVICE_1 "station_ex1" // name


// -------------------------- for default connection names ------------------------------
// i.e., http://hostname.local/
#define HOSTNAME_BASE "esp8266-iot" // for local used.
#define HOSTNAME ((String(HOSTNAME_BASE)+"-"+LSERVICE_1).c_str()) // for local used.


// -------------------------- other settings ------------------------------
// all the TMO values is restricted to no more than 35 minutes; see the Timeout() for detail. however,
// cascading could overcome.
#define TMO_IOT_LOOP_PERIOD 600 // IoT polling at each 600ms
#define TMO_STA_CONN_HEALTH_PERIOD 6000 // each 6 seconds to check the connection health by STA(while ping is alive)
#define TMO_MDNS_Q_PERIOD 30000 // each 30 seconds to query services

// [Multicast]
#define MULTICAST_ADDRESS "239.255.255.250"
#define MULTICAST_PORT "8888"
#define MULTICAST_BUFF_SIZE 15 // default is 16 in total. only (limited)for receiver.
#define MULTICAST_TR 1 // transmitting mode
#define MULTICAST_RV 2 // receiving mode


// -------------------------- main-control variables ------------------------------

const char *const WIFI_CRED[][2]={ // wifi credential
    {"ESP_TESTAP", "87654321"}, // the first one will be used which is in AP mode.
    {"Office", "123456"},
    {"Xperia X Performance_bc10", "e848acbcfd98"},
    {"etc", "etc"},
};

typedef struct smDnsRecord{ // for mdns
    const char *service;
    const unsigned port;
    const char *proto;
} smDnsRecord;

const smDnsRecord mdns_sskn[]={ // for mdns. the known services this device needs from other devices.
    {"http", 80, "tcp"},
    {"https", 443, "tcp"},
    {"test", 81, "tcp"},
    {"motor", 8080, "tcp"},
#if STA_MODE
    {"multicast", 8888, "udp"},
#endif // STA_MODE
};

bool mdns_enabled=false; // set true when connected. could be disabled once aimed and got the ip.

// for demanding STA to connect AP or not, default is yes, controlled by user.
unsigned sta_do_the_connect=1;

// for demanding this local device broadcast or not. it is supposed to switched by a http request.
unsigned multicast_is_broadcasting=0; // 0, disable; 1/MULTICAST_TR, as the transmitter; 2/MULTICAST_RV, as the receiver. and running.

// for where multicasted this device got from of the string. however, since the role can not both at the same time,
// the multicast receiver could still use this str to broadcast.
String multicast_got_or_put_str="";

// for http GET returned
String http_got_str="";

// for connected remote ap ip, in STA mode
char remote_ap_ip[16] = {0};

// remote http server ip, for doing http requests. the auto-http requests is on only if this var assigned.
char http_request_ip[16] = {0};

unsigned is_station_mode_established=0; // change bool to unsigned because elsewhere IRAM_ATTR used.

unsigned wifi_ap_credential_idx=0; // for setting up the ap credential index in WIFI_CRED. default is 0.

String ap_credential_custom_name, ap_credential_custom_pw, sta_credential_custom_name, sta_credential_custom_pw; // runtime specified.

ESP8266WebServer *server_p;

ESP8266HTTPUpdateServer httpUpdater; // webupdater, will be http://HOSTNAME.local/update.

ESP8266WiFiMulti *WiFiMulti=0; // for sta mode.

String webupd_addr=""; // the target url for this device processing remote update.

unsigned force_update=0; // force remote update to start immediately.

String uri_list=""; // for listing the uris this device provided.

unsigned ap_mode_or_sta_mode=1; // be ap or sta, default is ap. could be changed the role by http request /tosta or toap.


// -------------------------- ap mode ------------------------------

bool AP_enter_ap_mode(){ // use WIFI_CRED. default is wifi_ap_credential_idx=0. idx can be changed by http request of /getap and /setap.
    if (ap_credential_custom_name!=""){
        WiFi.softAP(ap_credential_custom_name.c_str(), ap_credential_custom_pw.c_str());
        IPAddress myIP = WiFi.softAPIP();
        MY_DBG(Serial.print("AP IP address: "));
        MY_DBG(Serial.println(myIP));
        return true;
    }
    else if (wifi_ap_credential_idx<sizeof(WIFI_CRED)/sizeof(WIFI_CRED[0])){
        WiFi.softAP(WIFI_CRED[wifi_ap_credential_idx][0], WIFI_CRED[wifi_ap_credential_idx][1]);
        IPAddress myIP = WiFi.softAPIP();
        MY_DBG(Serial.print("AP IP address: "));
        MY_DBG(Serial.println(myIP));
        return true;
    }
    return false;
}


// -------------------------- station mode ------------------------------

bool STA_enter_station_mode(){ // 12 seconds waiting
    unsigned char u=0;

    // Connect to WiFi network
    MY_DBG(Serial.println(""));
    MY_DBG(Serial.println("[-= Enter Station Mode =-]"));
    MY_DBG(Serial.print("WiFi Connecting..."));

    // correct order
    WiFi.disconnect(); // since cases could WiFi reconnect.
    WiFi.mode(WIFI_OFF); // come up with disconnect, not sure ok or not.
    WiFi.mode(WIFI_STA);
    WiFi.begin();
    WiFi.hostname(HOSTNAME); // set after WiFi.begin().

    if (!WiFiMulti){
        WiFiMulti=new ESP8266WiFiMulti;
        if (!WiFiMulti) return false;

        if (sta_credential_custom_name!="")
            WiFiMulti->addAP(sta_credential_custom_name.c_str(), sta_credential_custom_pw.c_str());

        for (int i=0; i<(sizeof(WIFI_CRED)/sizeof(WIFI_CRED[0])); i++)
            WiFiMulti->addAP(WIFI_CRED[i][0], WIFI_CRED[i][1]);
    }

    while (WiFiMulti->run() != WL_CONNECTED) {
        delay(200);
        MY_DBG(Serial.print("."));
        if (u++>60){ // 12 seconds, might not enough
            MY_DBG(Serial.println(" WiFi connection failed..."));
            return false;
        }
    }
    MY_DBG(Serial.println("WiFi connected"));

    // Print the remote MAC address
    uint8_t macAddr[6];
    WiFi.macAddress(macAddr);
    MY_DBG(Serial.printf("Remote MAC adr: %02X:%02X:%02X:%02X:%02X:%02X\r\n",\
        macAddr[0], macAddr[1], macAddr[2], macAddr[3], macAddr[4], macAddr[5]));

    ip_info info;
    wifi_get_ip_info(STATION_IF, &info);
    MY_DBG(Serial.printf("IP ADDR: " IPSTR "\r\n", IP2STR(&info.ip)));
    MY_DBG(Serial.printf("GATEWAY: " IPSTR "\r\n", IP2STR(&info.gw)));
    MY_DBG(Serial.printf("NETMASK: " IPSTR "\r\n", IP2STR(&info.netmask)));

    // resolve the remote ip
    uint32 x=*(uint32*)(&info.ip)&*(uint32*)(&info.netmask);
    ip_addr y=*(ip_addr*)(&x);
    snprintf(remote_ap_ip, 16, "%d.%d.%d.%d",\
        ip4_addr1(&y)? ip4_addr1(&y): 1,\
        ip4_addr2(&y)? ip4_addr2(&y): 1,\
        ip4_addr3(&y)? ip4_addr3(&y): 1,\
        ip4_addr4(&y)? ip4_addr4(&y): 1
        );
    MY_DBG(Serial.print(F("Remote AP IP: ")));
    MY_DBG(Serial.println(remote_ap_ip));

    MY_DBG(Serial.printf("Default local hostname: %s\r\n", WiFi.hostname().c_str()));
    MY_DBG(Serial.print("DNS #1, #2 IP: "));
    MY_DBG(WiFi.dnsIP().printTo(Serial));
    MY_DBG(Serial.print(", "));
    MY_DBG(WiFi.dnsIP(1).printTo(Serial));
    MY_DBG(Serial.println());
    MY_DBG(Serial.printf("RSSI: %d dBm\r\n", WiFi.RSSI()));
    MY_DBG(WiFi.printDiag(Serial));
    
    // Print the local IP address
    MY_DBG(Serial.println(""));
    MY_DBG(Serial.print("IP is assigned: "));
    MY_DBG(Serial.println(WiFi.localIP()));
    return true;
}

void STA_drop_station_mode(){
    WiFi.disconnect();
    WiFi.mode(WIFI_OFF); // no this line will wdt-reset
}


// -------------------------- http server ------------------------------

ESP8266WebServer* HTTPH_create_http_server(){ // ESP8266WebServer & MDNS & Updater facilities
    // Create an instance of the server
    // specify the 80 port to listen on as an argument
    ESP8266WebServer *a=new ESP8266WebServer(80);

    // setup the mdns.
    if (!MDNS.begin(HOSTNAME)) { // Start the mDNS responder
        MY_DBG(Serial.println("Error setting up MDNS responder!"));
    }
    MY_DBG(Serial.println("mDNS responder started"));

    // setup the updater; which is http://hostname/update.
    httpUpdater.setup(a);

    // Start the http server
    a->begin();

    // config mdns.
    MDNS.addService(LSERVICE_1, "tcp", 80);

    MY_DBG(Serial.println(String("UPDATE page is http://")+HOSTNAME+".local:80/update"));
    MY_DBG(Serial.println("HTTP Server started"));
    return a;
}

void remove_the_http_server(){
    if (server_p) delete server_p;
    server_p=0;
}


// -------------------------- http client ------------------------------

bool HTTPC_http_client_connect(const char *url){
    WiFiClient client;
    HTTPClient http; // must be declared after WiFiClient for correct destruction order, because used by http.begin(client,...)
    bool returned_state=false; // true only if got data.

    // configure server and url
    http.begin(client, url);

    // start connection and send HTTP header
    int httpCode = http.GET();
    if (httpCode > 0) {
        // HTTP header has been send and Server response header has been handled

        // file found at server
        if (httpCode == HTTP_CODE_OK) {

            // get lenght of document (is -1 when Server sends no Content-Length header)
            int len = http.getSize();

            #if 0 // with API

                http_got_str=http.getString();
                MY_DBG(Serial.println(http_got_str));

            #else // or "by hand"

                // create buffer for read
                uint8_t buff[128] = {0};
                http_got_str="";

                // get tcp stream
                WiFiClient * stream = &client;

                // read all data from server
                while (http.connected() && (len > 0 || len == -1)) {
                    // read up to 128 byte
                    int c = stream->readBytes(buff, std::min((size_t)len, sizeof(buff)-1));
                    if (!c) {
                        MY_DBG(Serial.println("[read timeout]"));
                        http_got_str="";
                        returned_state=false;
                        break; // must have or it will stuck here! and then if stuck at GET(), set timeout
                    }

                    buff[c]=0;
                    http_got_str+=(char*)buff;

                    if (len > 0) len -= c;
                    returned_state=true;
                }

            #endif // or "by hand"

        }
        else http_got_str="";
    }
    else {
        http_got_str="";
        MY_DBG(Serial.printf("[HTTP GET... failed, error: %s]\r\n", http.errorToString(httpCode).c_str()));
    }
    http.end();
    return returned_state;
}


// -------------------------- mdns ------------------------------

unsigned mdns_sskn_len=sizeof(mdns_sskn)/sizeof(smDnsRecord);

// the count is to pause the auto query for explicitly manual query.
unsigned mDnsQuery_count=0; // the manual query result on how many same service devices were found.

void mDnsQuery(){ // unable to query the provided itselves. especially note that which can be queried should use (USE_MDNS_FULL)
    if (mDnsQuery_count) return;
    MY_DBG(printf("Sending mDNS query\r\n"));
    for (int i=0; i<mdns_sskn_len; i++){
        int n = MDNS.queryService(mdns_sskn[i].service, mdns_sskn[i].proto); // Send out query for those tcp services
        if (!n) MY_DBG(printf("no service [%s] found.\r\n", mdns_sskn[i].service));
        else {
            MY_DBG(printf("service(s) found\r\n"));
            for (int j = 0; j < n; j++)
                MY_DBG(printf("[%s] %d: %s (%s: %d)\r\n",\
                    mdns_sskn[i].service, j+1, MDNS.hostname(j).c_str(), MDNS.IP(j).toString().c_str(), MDNS.port(j)));
        }
    }
    MY_DBG(printf("mDNS query done\r\n"));
}

unsigned mDnsQueryStart(const char *serv_name, const char *serv_protocol){ // start/cont/end are bundled use together.
    // return the number of devices found.
    return mDnsQuery_count=MDNS.queryService(serv_name, serv_protocol);
}

bool mDnsQueryCont(unsigned idx, IPAddress &ip, unsigned &port, String &hostname){ // start/cont/end are bundled use together.
    // use idx to get the found. idx is from 0 to mDnsQuery_count-1.
    if (idx>=mDnsQuery_count) return false;
    hostname=MDNS.hostname(idx);
    ip=MDNS.IP(idx);
    port=MDNS.port(idx);
    return true;
}

void mDnsQueryEnd(){ // start/cont/end are bundled use together.
    mDnsQuery_count=0;
}


// -------------------------- multicast wrapped; multicast is only for sta mode ------------------------------

WiFiUDP Udp;
IPAddress addressMulticast=0;
IPAddress ifaddrMulticast=0;
unsigned portMulticast=0;
char multicast_buffer[MULTICAST_BUFF_SIZE+1]; // default is 16 in total. only (limited)for receiver.

void beginMulticastTransmitter(const char *mcast_address=MULTICAST_ADDRESS, const char *port=MULTICAST_PORT){
    // the timing and contents and tr or recv all are controlled by client code.
    if (ap_mode_or_sta_mode){ // sta mode.
        ifaddrMulticast=WiFi.localIP();
        addressMulticast=ipaddr_addr(mcast_address);
        portMulticast=String(port).toInt();
    }
}

void beginMulticastReceiver(const char *mcast_address=MULTICAST_ADDRESS, const char *port=MULTICAST_PORT){
    // the timing and contents and tr or recv all are controlled by client code.
    if (ap_mode_or_sta_mode){ // sta mode.
        ifaddrMulticast=WiFi.localIP();
        addressMulticast=ipaddr_addr(mcast_address);
        portMulticast=String(port).toInt();
        Udp.beginMulticast(ifaddrMulticast, addressMulticast, portMulticast);
    }
}

void transmitMulticast(){ // the timing and contents and tr or recv all are controlled by client code.
    if (ap_mode_or_sta_mode && (multicast_is_broadcasting==MULTICAST_TR)){
        Udp.beginPacketMulticast(addressMulticast, portMulticast, ifaddrMulticast);
        Udp.write(multicast_got_or_put_str.c_str());
        Udp.endPacket();
    }
}

bool receiveMulticast(){ // the timing and contents and tr or recv all are controlled by client code.
    if (ap_mode_or_sta_mode && (multicast_is_broadcasting==MULTICAST_RV)){
        int packetLength=Udp.parsePacket();
        if (packetLength>0){
            if (packetLength>MULTICAST_BUFF_SIZE) packetLength=MULTICAST_BUFF_SIZE;
            Udp.read(multicast_buffer, packetLength);
            multicast_buffer[packetLength]=0;
            multicast_got_or_put_str=multicast_buffer;
            ///// use IPAddress destinationIP() to identify it is for multicast address.
            ///// use IPAddress remoteIP() to identify the remote address.
            ///// use uint16_t remotePort() to identify the remote port.
            return true;
        }
    }
    return false;
}

void stopMulticast(){ // if stop, multicast_is_broadcasting must reassign if reuse.
    // the timing and contents and tr or recv all are controlled by client code.

    if (ap_mode_or_sta_mode){
        multicast_is_broadcasting=0;
        Udp.stop(); // especially note that the receiver is of concerns, so better to stop if not used.
    }
}


// -------------------------- Remote updater ------------------------------
// the device can not update itself because this updater has yet not found any exit point.

void gbl_update_started() {
  MY_DBG(Serial.println("CALLBACK:  HTTP update process started"));
}

void gbl_update_finished() {
  MY_DBG(Serial.println("CALLBACK:  HTTP update process finished"));
}

void gbl_update_progress(int cur, int total) {
  MY_DBG(Serial.printf("CALLBACK:  HTTP update process at %d of %d bytes...\n", cur, total));
}

void gbl_update_error(int err) {
  MY_DBG(Serial.printf("CALLBACK:  HTTP update fatal error code %d\n", err));
}

void gbl_updater(const char *url) {
    // wait for WiFi connection

    WiFiClient client;

    // The line below is optional. It can be used to blink the LED on the board during flashing
    // The LED will be on during download of one buffer of data from the network. The LED will
    // be off during writing that buffer to flash
    // On a good connection the LED should flash regularly. On a bad connection the LED will be
    // on much longer than it will be off. Other pins than LED_BUILTIN may be used. The second
    // value is used to put the LED on. If the LED is on with HIGH, that value should be passed
    // ESPhttpUpdate.setLedPin(LED_BUILTIN, LOW);

    // Add optional callback notifiers
    ESPhttpUpdate.onStart(gbl_update_started);
    ESPhttpUpdate.onEnd(gbl_update_finished);
    ESPhttpUpdate.onProgress(gbl_update_progress);
    ESPhttpUpdate.onError(gbl_update_error);

    t_httpUpdate_return ret = ESPhttpUpdate.update(client, url);
    // Or:
    // t_httpUpdate_return ret = ESPhttpUpdate.update(client, "server", 80, "file.bin");

    switch (ret) {
        case HTTP_UPDATE_FAILED:
            MY_DBG(Serial.printf("HTTP_UPDATE_FAILD Error (%d): %s\r\n", ESPhttpUpdate.getLastError(), ESPhttpUpdate.getLastErrorString().c_str()));
            break;
        case HTTP_UPDATE_NO_UPDATES:
            MY_DBG(Serial.println("HTTP_UPDATE_NO_UPDATES"));
            break;
        case HTTP_UPDATE_OK:
            MY_DBG(Serial.println("HTTP_UPDATE_OK"));
            break;
    }
}


// -------------------------- other functions ------------------------------
bool Timeout(unsigned ms, unsigned &store_start_time_us, bool one_shot=false, bool one_shot_lasting=false){
    // note: the var store_start_time_us must be exclusively used by this function because it could be modified by this function.
    // !!!!
    // especially note that the micros() will wrap around after 4294967296us, which is around 70 minutes.
    // so, do not use timeout value > 35 minutes; or another abnormal case is past time > 35 minutes before checking.
    // that is, avoid from abnormal of the above two is must by user.

    if (one_shot && !store_start_time_us) return one_shot_lasting;

    ///// if (micros()>=(ms*1000+store_start_time_us)){ ///// this is not ok, will abnormal after power-on 70 minutes.
    if (int(micros())-int(ms*1000+store_start_time_us)>=0){ ///// this is ok

        store_start_time_us=one_shot? 0: micros();
        return true;
    }
    return false;
}


// -------------------------- main controls ------------------------------

void the_http_request(){

    extern void my_http_request(); // all the http requests from this device could be controlled in this function.
    if (*http_request_ip) my_http_request(); // called only if http_request_ip assigned.

}

void the_http_server(){

    server_p=HTTPH_create_http_server();

    server_p->on("/", [](){
        server_p->send(200, "text/html", ap_mode_or_sta_mode? "<h1>WiFi STATION</h1>": "<h1>WiFi AP</h1>");
    });

    server_p->on("/version", []() {server_p->send(200, "text/plain", MY_VERSION_NUMBER);});

    server_p->on("/reset", []() {
        server_p->send(200, "text/plain", "now reset...");
        delay(1000);
        while (1);
    });

    server_p->on("/s", []() {server_p->send(200, "text/plain", String(random(10)+1).c_str());});

    server_p->on("/getap", [](){
        String a("choose the number:\r\n");
        for (int i=0; i<(sizeof(WIFI_CRED)/sizeof(WIFI_CRED[0])); i++){
            a+=String(i+1)+". ["+WIFI_CRED[i][0]+", "+/*WIFI_CRED[i][1]*/"***"+"]\r\n";
        }
        a=a+"currently is "+(wifi_ap_credential_idx+1)+". ["+WIFI_CRED[wifi_ap_credential_idx][0]+"]\r\n";
        server_p->send(200, "text/plain", a.c_str());
    });

    server_p->on("/setap", [](){ // ?n=<i>.
        String n=server_p->arg("n");
        int nn=n.toInt()-1;
        if (nn>=0 && nn<sizeof(WIFI_CRED)/sizeof(WIFI_CRED[0])) wifi_ap_credential_idx=nn;
        else wifi_ap_credential_idx=0;

        #if MYDB
            cDataBase("/settings").ReplaceWordsEx("wifi_ap_credential_idx", 0, wifi_ap_credential_idx);
        #endif // MYDB

        server_p->send(200, "text/plain", (String(WIFI_CRED[wifi_ap_credential_idx][0])+" chosen.").c_str());
    });

    server_p->on("/toap", [](){
        server_p->send(200, "text/plain", "done.");
        ap_mode_or_sta_mode=0;

        #if MYDB
            cDataBase("/settings").ReplaceWordsEx("ap_mode_or_sta_mode", 0, ap_mode_or_sta_mode);
        #endif // MYDB

        delay(1000);
        while (1); // reset to change role.
    });

    server_p->on("/tosta", [](){
        server_p->send(200, "text/plain", "done.");
        ap_mode_or_sta_mode=1;

        #if MYDB
            cDataBase("/settings").ReplaceWordsEx("ap_mode_or_sta_mode", 0, ap_mode_or_sta_mode);
        #endif // MYDB

        delay(1000);
        while (1); // reset to change role.
    });

    server_p->on("/credential", [](){ // ?r=<the role is ap or sta>&n=<name>&p=<password>.
        server_p->send(200, "text/plain", "done.");
        String role=server_p->arg("r");
        String cname=server_p->arg("n");
        String pw=server_p->arg("p");

        #if MYDB
            unsigned n_len=cname.length()+1, p_len=pw.length()+1;
            if (role=="ap"){
                cDataBase("/settings").ReplaceBytesEx("ap_credential_custom_name", 0, cname.c_str(), n_len, n_len);
                cDataBase("/settings").ReplaceBytesEx("ap_credential_custom_pw", 0, pw.c_str(), p_len, p_len);
            }
            else if (role=="sta"){
                cDataBase("/settings").ReplaceBytesEx("sta_credential_custom_name", 0, cname.c_str(), n_len, n_len);
                cDataBase("/settings").ReplaceBytesEx("sta_credential_custom_pw", 0, pw.c_str(), p_len, p_len);
            }
        #endif // MYDB

    });

    // assign the update website url to this device(it is intended for this local device connecting to)
    server_p->on("/webupdinfo", []() { // http://<ip address>/webupdinfo?addr=<remote url; e.g., http://192.168.1.1/a.bin>.
        String addr=server_p->arg("addr");
        if (addr=="") server_p->send(404, "text/plain", "0. page not found.");
        else {
            webupd_addr=addr;
            server_p->send(200, "text/plain", ("1. accepted: "+webupd_addr).c_str());
        }
    });

    // force global update immediately
    server_p->on("/forceupdate", []() {
        force_update=1;
        server_p->send(200, "text/plain", String("1. accepted. on 10 seconds to start updating...").c_str());
    });

    server_p->on("/listcmds", []() { // list all commands.
        server_p->send(200, "text/plain", uri_list.c_str());
    });

    // use uri_list+=str; to expand uri list.
    uri_list=\
        "/listcmds\r\n"\
        "/\r\n"\
        "/version\r\n"\
        "/reset\r\n"\
        "/s\r\n"\
        "/update (by selecting an update file from pc and upload to update)\r\n"\
        "/webupdinfo?addr=<remote url; e.g., http://192.168.1.1/a.bin>\r\n"\
        "/forceupdate\r\n"\
        "/getap\r\n"\
        "/setap?n=<i>\r\n"\
        "/credential?r=<the role is ap or sta>&n=<name>&p=<password>\r\n"\
        "/toap\r\n"\
        "/tosta\r\n";
}

void setup_IoT(){
    if (ap_mode_or_sta_mode) MY_DBG(Serial.println("station mode entered."));
    else {
        MY_DBG(Serial.println("Configuring access point..."));
        AP_enter_ap_mode();
        mdns_enabled=true;

        the_http_server(); // setup the http server
    }
}

void loop_IoT(){
    static unsigned tmo1=micros();
    if (!Timeout(TMO_IOT_LOOP_PERIOD, tmo1)) return; // polling at each 75ms

    if (ap_mode_or_sta_mode){ // station mode.
        if (!sta_do_the_connect){
            if (is_station_mode_established){
                is_station_mode_established=0;
                STA_drop_station_mode();
            }
            return; // here will return if no station connection, so latter code would not run.
        }
        static unsigned tmo2=micros(), tmo02=tmo2; // tmo02, after 3 seconds starts to connect.
        if (Timeout(3000, tmo02, true) || Timeout(TMO_STA_CONN_HEALTH_PERIOD, tmo2, true, true)){
            if (!is_station_mode_established){
                mdns_enabled=is_station_mode_established=STA_enter_station_mode(); // it is blocking wait.
                static unsigned fault_retry_cnt=0;
                if (is_station_mode_established){ // run at here since mdns needs the ip or wdt-reset.
                    fault_retry_cnt=0;

                    remove_the_http_server();
                    the_http_server(); // setup the http server

                    strcpy(http_request_ip, remote_ap_ip);

                }
                else { // a fault case that resulting wdt reset and then sta always invalid, so wdt reset again to retry!!!!!
                    tmo2=micros();
                    if (fault_retry_cnt++>25) while (1);
                }
                return;
            }
        }
        else return;
    }

    if (mdns_enabled){
        MDNS.update();

        //// static unsigned tmo4=micros();
        //// if (Timeout(TMO_MDNS_Q_PERIOD, tmo4)) mDnsQuery(); // each 30 seconds to query services.

    }

    server_p->handleClient(); // handles http requests from remotes.

    if (force_update && webupd_addr!=""){ // handles update.
        static unsigned tmo3=micros();
        if (force_update==1){
            force_update=2;
            tmo3=micros();
        }
        else if ((force_update==2) && Timeout(10000, tmo3, true)){ // 10 seconds to start
            force_update=0;
            gbl_updater(webupd_addr.c_str());
        }
    }

    the_http_request(); // for local http request to remote
}

void my_http_request(){
    HTTPC_http_client_connect((String("http://")+http_request_ip+"/s").c_str());
}




// -------------------------- this project ------------------------------
// ----------------------------- periodically http to the ap ----------------------------------------------------
void setup(){
    MY_DBG(Serial.begin(115200));
    MY_DBG(while (!Serial) delay(50));
    MY_DBG(Serial.println());

    #if MYDB
        unsigned boot_up_times=0;
        unsigned char buff[32];
        cDataBase db("/settings");
        db.Open();
        db.ReadWords(boot_up_times, "boot_up_times");
        db.ReadWords(wifi_ap_credential_idx, "wifi_ap_credential_idx");
        db.ReadWords(ap_mode_or_sta_mode, "ap_mode_or_sta_mode");

        buff[0]=0; db.ReadData(buff, 32, "ap_credential_custom_name", 0); ap_credential_custom_name=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "ap_credential_custom_pw", 0); ap_credential_custom_pw=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "sta_credential_custom_name", 0); sta_credential_custom_name=(char*)buff;
        buff[0]=0; db.ReadData(buff, 32, "sta_credential_custom_pw", 0); sta_credential_custom_pw=(char*)buff;

        db.Close();

        ++boot_up_times;
        cDataBase("/settings").ReplaceWordsEx("boot_up_times", 0, boot_up_times);
        if (!(boot_up_times%10)){
            cDataBase("/settings").Renew();

            ap_mode_or_sta_mode=0; // force to in ap mode, reboot to recover.
        }
    #endif // MYDB

    // IoTs
    setup_IoT();
}

void loop(){
    loop_IoT();

    static String a=http_got_str;
    MY_DBG(if (a!=http_got_str) Serial.println(http_got_str));
    a=http_got_str;
}
